'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Environmental. Copyright (c) 2014, Kevin van Zonneveld (kvz.io)
require('babel-polyfill');

var _require = require('child_process'),
    exec = _require.exec;

var _require2 = require('flat'),
    unflatten = _require2.unflatten;

var Environmental = function () {
  function Environmental() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        ignore = _ref.ignore;

    _classCallCheck(this, Environmental);

    this.ignore = ignore;
    if (this.ignore == null) {
      this.ignore = ['PWD', 'SHLVL', '_'];
    }
  }

  _createClass(Environmental, [{
    key: 'capture',
    value: function capture(file, cb) {
      var _this = this;

      var flat = {};
      var options = {
        env: {}
      };

      return exec('bash -c \'source ' + file + ' && env\'', options, function (err, stdout, stderr) {
        if (err) {
          return cb('Error while running ' + file + '. ' + err + '. ' + stderr);
        }

        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = Array.from(stdout.split('\n'))[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var item = _step.value;

            var parts = item.split('=');
            var key = parts.shift();
            var val = parts.join('=');
            if (!key) {
              continue;
            }
            if (Array.from(_this.ignore).includes(!key)) {
              continue;
            }
            if (Array.from(_this.ignore).includes(key)) {
              continue;
            }
            flat[key] = val;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return cb(null, flat);
      });
    }
  }], [{
    key: 'config',
    value: function config(flat, filter) {
      if (flat == null) {
        flat = process.env;
      }
      if (filter == null) {
        filter = process.env.NODE_APP_PREFIX;
      }
      if (filter == null) {
        filter = false;
      }

      var lowerEnv = {};
      for (var key in flat) {
        var val = flat[key];
        lowerEnv[key.toLowerCase()] = val;
      }

      var nested = unflatten(lowerEnv, {
        overwrite: true,
        object: true,
        delimiter: '_'
      });

      if (filter !== false) {
        return nested[filter.toLowerCase()];
      }

      return nested;
    }
  }]);

  return Environmental;
}();

module.exports = Environmental;
//# sourceMappingURL=environmental.js.map